#ifndef _listado_h
#define _listado_h

class color_listado1: public CButton {
   public:
      virtual void create (CWnd *par, CWnd *par1, CRect *in_rect);
	  int obtener_numero_campo(int numero);
	  int obtener_condicion(int numero);
	  void obtener_operador(int numero,char *texto);
	  void obtener_valor(int numero,char *texto);
	  int obtener_campo(int numero);
	  void obtener_texto(int numero,int *r,int *g,int *b);
	  void obtener_fondo(int numero,int *r,int *g,int *b);
	  color_listado1();
	  virtual ~color_listado1();
   private:
      CWnd *parent;
	  CWnd *parent1;
	  CComboBox *combo_num[10];
	  CComboBox *combo_con[10];
	  CComboBox *combo_ope[10];
      CComboBox *combo_cam[10];
	  CEdit *campo[10];
	  CButton *boton_for[10];
	  CButton *boton_tex[10];
	  CButton *boton_bac[10];
	  CButton *boton_fon[10];
	  CStatic *label[8];
	  int cr[10],cg[10],cb[10];
	  int fr[10],fg[10],fb[10];
   protected:
      //{{AFX_MSG(color_listado1)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP() 
};

class color_listado: public CDialog {
   public:
      virtual void create(CWnd *par);
	  virtual void salir();
	  virtual void continuar();
	  color_listado();
      virtual ~color_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      color_listado1 color1;
   private:
      CButton *boton[2];
	  CWnd *parent;
   protected:
      //{{AFX_MSG(color_listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	 	 void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class formato_listado1: public CButton {
   public:
      virtual void create (CWnd *par1, CRect *in_rect,int inicial);
	  int obtener_regis();
	  formato_listado1();
	  virtual ~formato_listado1();
   private:
      CWnd *parent;
	  CButton *boton[7];
   protected:
      //{{AFX_MSG(formato_listado1)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP() 
};

class formato_listado2: public CButton {
   public:
      virtual void create(CWnd *par1, CRect *in_rect,int numero_campos);
      int obtener_campo(int numero);
      formato_listado2();
      virtual ~formato_listado2();
      CEdit *campo[4];
      CSpinButtonCtrl *spin[4];
      CStatic *label[8];
   protected:
      //{{AFX_MSG(formato_listado2)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class formato_listado: public CDialog {
   public:
      virtual void create(CWnd *par);
	  virtual void salir();
	  virtual void continuar();
	  formato_listado();
      virtual ~formato_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      formato_listado1 forlis1;
      formato_listado2 forlis2;
   private:
      CButton *boton[2];
	  CWnd *parent;
   protected:
      //{{AFX_MSG(formato_listado)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	 	 void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class calculado_listado1: public CButton {
   public:
      virtual void create (CWnd *par1, CRect *in_rect);
	  int obtener_tipo();
	  calculado_listado1();
	  virtual ~calculado_listado1();
   private:
      CButton *boton[2];
};

class calculado_listado2: public CButton {
   public:
      virtual void create(CWnd *par1, CRect *in_rect);
      int obtener_longitud();
      calculado_listado2();
      virtual ~calculado_listado2();
   private:
      CEdit *campo;
	  CStatic *label;
      CSpinButtonCtrl *spin;
   protected:
      //{{AFX_MSG(calculado_listado2)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class calculado_listado: public CDialog {
   public:
      virtual void create(CWnd *par);
	  virtual void salir();
	  virtual void continuar();
	  calculado_listado();
      virtual ~calculado_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      calculado_listado1 callis1;
      calculado_listado2 callis2;
   private:
      CButton *boton[2];
	  CWnd *parent;
   protected:
      //{{AFX_MSG(calculado_listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	 	 void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 void OnClose();
		 HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class sql_listado1: public CButton {
   public:
      virtual void create(CWnd *par1, CRect *in_rect,char *sql);
      void obtener_campo(char *texto);
      sql_listado1();
      virtual ~sql_listado1();
   private:
      CEdit *campo;
	  CStatic *label;
   protected:
      //{{AFX_MSG(sql_listado1)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP() 
   
};

class sql_listado: public CDialog {
   public:
      virtual void create(CWnd *par,int num);
	  virtual void sql();
      virtual void salir();
	  sql_listado();
      virtual ~sql_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      sql_listado1 sqllis1;
   private:
      int numero_campo;
      CButton *boton[2];
	  CWnd *parent;
   protected:
      //{{AFX_MSG(sql_listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
         HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
		 void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	     void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class grabar_listado1: public CButton {
   public:
      virtual void create(CWnd *par1, CRect *in_rect,char *informe,char *descripcion);
      void obtener_campo(int numero,char *texto);
      void set_focus(int numero);
      CWnd *obtener_ventana(int numero);
	  grabar_listado1();
      virtual ~grabar_listado1();
   private:
      CEdit *campo[2];
	  CStatic *label[4];
   protected:
      //{{AFX_MSG(grabar_listado1)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP() 
};

class grabar_listado: public CDialog {
   public:
      virtual void create(CWnd *par2, CWnd *par,int fin);
	  virtual void grabar();
      virtual void salir();
	  grabar_listado();
      virtual ~grabar_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      grabar_listado1 gralis1;
   private:
      CButton *boton[2];
	  CWnd *parent;
	  CWnd *parent_lis;
	  int finalizar;
   protected:
      //{{AFX_MSG(grabar_listado)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	     void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class campos_listado1: public CButton {
   public:
      virtual void create(CWnd *par, CRect *in_rect, CWnd *par1);
	  campos_listado1();
      virtual ~campos_listado1();
	  CListBox *ventana_lista;
   private:
	  CWnd *parent;
   protected:
      //{{AFX_MSG(campos_listado1)
         void OnSize(UINT nType,int cx,int cy);
		 BOOL OnCommand(WPARAM wParam,LPARAM lParam);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class campos_listado: public CDialog {
   public:
      virtual void create(CWnd *par, char *tabla, CWnd *par1);
	  virtual void salir();
	  virtual void continuar();
	  campos_listado();
      virtual ~campos_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      campos_listado1 camlis1;
	  char tab[16];
   private:
      CStatic *label;
      CButton *boton[2];
	  CWnd *parent;
	  CWnd *parent1;
   protected:
      //{{AFX_MSG(campos_listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	 	 void OnSize(UINT nType,int cx,int cy);
	     void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class tablas_listado1: public CButton {
   public:
      virtual void create(CWnd *par, CRect *in_rect,CWnd *par1);
      void obtener_campo(char *texto);
      void set_focus();
      CWnd *obtener_ventana();
      tablas_listado1();
      virtual ~tablas_listado1();
   private:
	  CComboBox *combo;
	  CStatic *label[2];
   protected:
      //{{AFX_MSG(tablas_listado1)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP() 
};

class tablas_listado: public CDialog {
   public:
      virtual void create(CWnd *par,CWnd *par1);
	  virtual void continuar();
      virtual void salir();
	  tablas_listado();
      virtual ~tablas_listado();
	  BOOL PreTranslateMessage(MSG *pMsg);
      tablas_listado1 tablis1;
   private:
      CButton *boton[2];
	  CWnd *parent;
	  CWnd *parent1;
   protected:
      //{{AFX_MSG(tablas_listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
		 HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class editlis1: public CWnd {
   public:
      virtual void create(CWnd *par, CRect *in_rect,CWnd *par1);
      void actualizar_ventana(CDC &dc);
	  void recupera_texto();
	  void terminar_linea();
	  void terminar_cuadro();
      void terminar_seleccion();
      void seleccionar_todo();
      int en_seleccion(char tipo_elemento,int numero);
	  void insertar_imagen();
	  void desplaza_vista(UINT nChar);
	  int boton_linea;
	  int boton_cuadro;
	  int boton_campo;
	  int boton_imagen;
	  int boton_texto;
	  int boton_negrita;
	  int boton_cursiva;
	  int indicador_linea;
	  int indicador_cuadro;
	  int indicador_campo;
	  int indicador_texto;
	  int indicador_sql;
      int seleccion;
      int indicador_seleccion;
      int indicador_pegar;
	  char tipo_letra[16];
	  int size_letra;
	  char size_linea;
	  int numero_texto;
	  int numero_campo;
	  int color_r_linea;
	  int color_g_linea;
	  int color_b_linea;
	  int color_r_fondo;
	  int color_g_fondo;
	  int color_b_fondo;
	  int linea_r;
	  int linea_g;
	  int linea_b;
	  int fondo_r;
	  int fondo_g;
	  int fondo_b;
	  CFont *fona;
	  int resumen;
	  int coorx,coory;
	  int resumenf,xf,yf;
	  int resumeni,xi,yi;
      int resumens,xs[2],ys[2];
   private:
      CWnd *parent;
	  CWnd *parent1;
	  CEdit *campo;
	  int arrastrando_cabecero,arrastrando_pie,arrastrando;
      int tipo_arrastrando,numero_arrastrando,difx_arrastrando,dify_arrastrando;
	  float difx[4],dify[4];
	  int xt,yt;
	  int xl,yl;
	  int xc,yc;
      int resumenl,resumenc;
   protected:
      //{{AFX_MSG(editlis1)
	     void OnPaint();
         void OnMouseMove(UINT nFlags,CPoint point);
		 void OnLButtonDown(UINT nFlags,CPoint point);
		 void OnLButtonUp(UINT nFlags,CPoint point);
		 void OnLButtonDblClk(UINT nFlags,CPoint point);
		 void OnNcMouseMove(UINT nHitTest,CPoint point);
		 void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
         void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		 HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class editlis: public CDialog {
   public:
      virtual void create(CWnd *par, char *nombre, char *descripcion, int numero);
      virtual void grabar(int finalizar);
	  virtual void salir();
      virtual void deshacer();
	  virtual void modificar_size();
	  virtual void cambiar_orientacion(char c);
      virtual void cambiar_letra(int numero);
	  virtual void cambiar_color(char f);
      virtual void portapapeles(int borrar);
	  virtual void seleccionar_color(char f);
      virtual void pegar();
      int prepara_memoria(int size);
      void set_boton(int numero);
      void unset_boton(int numero);
      void set_tool(int numero);
      void unset_tool(int numero);
	  editlis();
      virtual ~editlis();
	  BOOL PreTranslateMessage(MSG *pMsg);
      editlis1 ed1;
	  char informe[16];
      char descripcion[41];
	  int nt;
	  int x_texto[160],y_texto[160];
	  char texto[160][251];
	  int size_texto[160];
	  char font_texto[160][4];
	  int color_r_texto[160];
	  int color_g_texto[160];
	  int color_b_texto[160];
	  int fondo_r_texto[160];
	  int fondo_g_texto[160];
	  int fondo_b_texto[160];
	  int nc;
	  int x_campo[100],y_campo[100];
	  char tabla_campo[100][16];
	  char nombre_campo[100][16];
	  int lon_campo[100];
	  char sql_campo[100][533];
	  int size_campo[100];
	  char font_campo[100][4];
	  int color_r_campo[100];
	  int color_g_campo[100];
	  int color_b_campo[100];
	  int fondo_r_campo[100];
	  int fondo_g_campo[100];
	  int fondo_b_campo[100];
	  int tipo_campo[100];
	  int regis_pagina,num_repeticion,num_clave,num_columnas,espaciado;
	  char orientacion,and_condicion;
	  int y_cabecero,y_pie;
	  int x_anagrama,y_anagrama;
	  int ni,np[50];
	  char tipo_grafico[50];
	  int size_linea[50];
	  int color_r_linea[50];
	  int color_g_linea[50];
	  int color_b_linea[50];
	  int fondo_r_linea[50];
	  int fondo_g_linea[50];
	  int fondo_b_linea[50];
	  float x_punto[4][50],y_punto[4][50];
	  char extension[50][4];
	  int color_numero[10];
	  int color_condicion[10];
	  char color_operador[10][5];
      char color_valor[10][100];
	  int color_campo[10];
	  int color_r_con_t[10];
	  int color_g_con_t[10];
	  int color_b_con_t[10];
	  int color_r_con_f[10];
	  int color_g_con_f[10];
	  int color_b_con_f[10];
	  char fichero_g[100][256];
	  int n_fichero_g;
	  int ncolor;
      int modi;
	  char *buffer_deshacer[10];
      int num_deshacer;
      int tipo_deshacer[10];
	  CStatic *label[4];
	  tablas_listado tablis;
	  campos_listado camlis;
	  sql_listado sqllis;
      grabar_listado gralis;
      calculado_listado callis;
      formato_listado forlis;
	  color_listado color;
      int indicador_formato;
   private:
      CButton *boton[5];
	  CButton *tool[15];
	  CComboBox *combo[3];
	  CBitmapButton *bitmap[3];
	  CToolTipCtrl *tip;
	  char *textip[18];
	  CWnd *parent;
	  int numer;
   protected:
      //{{AFX_MSG(editlis)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
		 HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
		 void OnSize(UINT nType,int cx,int cy);
		 void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	     void OnClose();
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class rejilla_excel: public CGXGridWnd {
   public: 
      virtual void create(CWnd *par, CWnd *par1, CRect rect, char *fichero);
};

class visu_excel1: public CButton {
   public:
      virtual void create(CWnd *par, CRect *in_rect, char *fichero);
	  rejilla_excel *grid;
   protected:
      //{{AFX_MSG(visu_excel1)
         void OnSize(UINT nType,int cx,int cy);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class visu_excel: public CDialog {
   public:
      virtual void create (CWnd *par, char *informe,int numero);
	  virtual void copiar();
	  virtual void salir();
	  visu_excel();
      virtual ~visu_excel();
	  BOOL PreTranslateMessage(MSG *pMsg);
	  visu_excel1 gr1;
	  char informe[16];
	  int revision;
	  int num;
	  int cam_lon[100];
	  char cam_nom[100][16];
   private:
      CButton *boton[2];
	  int numer;
	  CWnd *parent;
   protected:
      //{{AFX_MSG(visu_excel)
	     void OnSize(UINT nType,int cx,int cy);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam); 
		 void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
		 void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class visu1: public CWnd {
   public:
      virtual void create(CWnd *par, CWnd *par1, CRect *in_rect);
      void actualizar_ventana(CDC &dc,int pagina);
      void desplaza_vista(UINT nChar);
	  static int CALLBACK selecciona_font(LPLOGFONT lplf,LPTEXTMETRIC lptm,DWORD dwStyle,LPARAM data);
   private:
      CWnd *parent;
	  CWnd *parent1;
   protected:
      //{{AFX_MSG(visu1)
	     void OnPaint();
		 void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
         void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class visu: public CDialog {
   public:
      virtual void create(CWnd *par, char *informe, int numero);
	  virtual void cambiar_revision(int rv);
	  virtual void escribe_pagina();
	  virtual void inicio();
	  virtual void final();
	  virtual void pagina_siguiente();
	  virtual void pagina_anterior();
	  virtual void imprimir();
      virtual void salir();
	  visu();
      virtual ~visu();
	  BOOL PreTranslateMessage(MSG *pMsg);
      visu1 vi1;
	  char informe[16];
	  char formato[8];
	  int revision;
	  int revision_inicial; 
	  int indicador_tabla;
	  FILE *fi;
	  char orientacion;
	  int pagina_actual;
	  int total_paginas;
	  long *inicio_pagina;
      float ancho[50],alto[50];
	  char fichero_g[100][256];
	  int n_fichero_g;
   private:
      CButton *boton[6];
	  CStatic *label[3];
	  CComboBox *combo;
	  CWnd *parent;
	  int numer;
   protected:
      //{{AFX_MSG(visu)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
		 void OnSize(UINT nType,int cx,int cy);
		 void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	     void OnClose();
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class campos1: public CButton {
   public:
      virtual void create(CWnd *par, CRect *in_rect, char lis[][16], int nlis);
	  campos1();
      virtual ~campos1();
	  CListBox *lista;
   protected:
      //{{AFX_MSG(campos1)
         void OnSize(UINT nType,int cx,int cy);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class campos: public CDialog {
   public:
      virtual void create(CWnd *parent, char *informe, int nu, CWnd *par, int posi);
	  virtual void salir();
      int obtener_indicador();
	  BOOL PreTranslateMessage(MSG *pMsg);
	  campos();
	  virtual ~campos();
      campos1 cam1;
	  CWnd *parent;
	  int numero;
   private:
      CStatic *label;
	  CButton *boton;
      int indicador;
   protected:
      //{{AFX_MSG(campos)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	 	 void OnSize(UINT nType,int cx,int cy);
	     void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	     void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class exec1: public CButton {
   public:
      virtual void create(CWnd *par1, CRect *in_rect, CWnd *par);
      int obtener_comparar();
	  void mensaje(char *texto);
	  void obtener_formato(char *formato);
	  int obtener_pagina();
	  void obtener_and(char *and);
	  void obtener_condicion(char *condicion);
	  void cambiar_condicion(int nueva);
	  void estado_botones(BOOL estado);
	  int grabar_condiciones(char *tab_con, char *informe, char *tex_er);
      CWnd *obtener_ventana(int numero);
	  exec1();
      virtual ~exec1();
	  CStatic *label[8];
   private:
      CButton *boton;
	  CComboBox *combo[3];
	  CEdit *campo[2];	  
	  CSpinButtonCtrl *spin;
	  CWnd *parent;
	  char condiciones[10][251];
	  int condicion_actual;
	  char device[101];
   protected:
      //{{AFX_MSG(exec1)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class parametros {
   public:  
	  char nombre[21];
	  char informe[16];
	  char nombrefic[7];
      int revision;
	  char condicion[2546];
	  char formato[8];
	  int comparar;
	  int pagina;
	  CStatic *label;
	  int codigo;
	  char dir[201];
	  char usu[21];
	  char pass[21];
};
	  
class exec: public CDialog {
   public:
      virtual void create(CWnd *par, char *informe, int revision, char *estado, int numero);
	  virtual void inicio_ejecucion();
	  virtual void final_ejecucion();
	  virtual void cancelar();
      virtual int salir();
	  virtual void ventana_campos();
	  void set_boton();
	  exec();
      virtual ~exec();
	  BOOL PreTranslateMessage(MSG *pMsg);
      exec1 ex1;
	  campos cam;
	  char informe[16];
	  HANDLE hThread;
	  int estado_ejecucion;
   private:
      CButton *boton[5];
	  CWnd *parent;
	  parametros *par;
	  int revision;
	  char estado[2];
	  int numer;
   protected:
      //{{AFX_MSG(exec)
	     HBRUSH OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
         void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	     void OnClose();
	  //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class lista_informes: public CListCtrl {
   public:
      void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
};

class listado1: public CButton {
   public:
      virtual void create(CWnd *par, CRect *in_rect);
	  virtual void asignar_imagen(int numero);  
	  virtual void actualizar_registro(char *informe);
      virtual int obtener_registro(int numero, char *informe, char *oficial, char *descripcion, char *fecha);
	  virtual int obtener_seleccionado();
	  char get_marca_edit(int numero);
	  char get_marca_rejilla(int numero);
	  char get_marca_ver(int numero);
	  char get_marca_exec(int numero);
	  void put_marca_edit(char *informe,char marca);
	  void put_marca_rejilla(char *informe,char marca);
	  void put_marca_ver(char *informe,char marca);
	  void put_marca_exec(char *informe,char marca);
	  BOOL PreTranslateMessage(MSG *pMsg);
	  lista_informes *lista;
	  CImageList *imagen;
	  CBitmap *peq;
	  CBitmap *mask;
   private:
      CWnd *parent; 
   protected:
      //{{AFX_MSG(listado1)
         void OnSize(UINT nType,int cx,int cy);
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

class listado: public CDialog {
   public:
      virtual void create(CWnd *parent, char *opcion, char autorizacion, char *no, char *di, char *us, char *pa, sql_context contexto, int b=73);
	  virtual int salir();
	  virtual void editar(int numero);
	  virtual void ver(int numero);
	  virtual void ver_rejilla(int numero);
	  virtual void nuevo();
	  virtual void ejecutar(int numero);
	  virtual void cerrar(int numero);
	  virtual void borrar(int numero);
	  int obtener_indicador();
      listado();
      virtual ~listado();
	  void set_tool(int numero);
      void unset_tool(int numero);
	  BOOL PreTranslateMessage(MSG *pMsg);
      listado1 li1;     
	  char nombre[21];
	  char nom[61];
	  char dir[201];
	  char usu[21];
	  char pass[21];
	  char acceso;
	  int indicador_ex[5];
	  int indicador_vi[5];
	  int indicador_ed[5];
	  int indicador_gr[5];
	  exec *ex;
	  visu *vi;
	  visu_excel *gr;
	  editlis *ed;
	  int size_bitmap;
	  sql_context contex_gen;
   private:
      CButton *tool[5];
      CButton *boton[2];
	  CBitmapButton *titulo;
	  CToolTipCtrl *tip;
	  char *textip[6];
	  int indicador;
   protected:
      //{{AFX_MSG(listado)
	     BOOL OnCommand(WPARAM wParam,LPARAM lParam);
         void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	 	 void OnSize(UINT nType,int cx,int cy);
	     void OnClose();
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};

extern DWORD colorW;
extern CFont *fonm;
extern CString xd_wnd_class;
extern int baseX,baseY,baseV,baseM,baseTX,baseTY;
extern char directorio_aplicacion[201];
extern char identificacion_aplicacion[51],nombre_aplicacion[11];

#endif
